/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ContactsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactsList{}

// ContactsList struct for ContactsList
type ContactsList struct {
	Results []Contact `json:"results"`
	Total int32 `json:"total"`
}

// NewContactsList instantiates a new ContactsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactsList(results []Contact, total int32) *ContactsList {
	this := ContactsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewContactsListWithDefaults instantiates a new ContactsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactsListWithDefaults() *ContactsList {
	this := ContactsList{}
	return &this
}

// GetResults returns the Results field value
func (o *ContactsList) GetResults() []Contact {
	if o == nil {
		var ret []Contact
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *ContactsList) GetResultsOk() ([]Contact, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *ContactsList) SetResults(v []Contact) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *ContactsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *ContactsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *ContactsList) SetTotal(v int32) {
	o.Total = v
}

func (o ContactsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableContactsList struct {
	value *ContactsList
	isSet bool
}

func (v NullableContactsList) Get() *ContactsList {
	return v.value
}

func (v *NullableContactsList) Set(val *ContactsList) {
	v.value = val
	v.isSet = true
}

func (v NullableContactsList) IsSet() bool {
	return v.isSet
}

func (v *NullableContactsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactsList(val *ContactsList) *NullableContactsList {
	return &NullableContactsList{value: val, isSet: true}
}

func (v NullableContactsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


